/******************************************************************************
 * JBoss, a division of Red Hat                                               *
 * Copyright 2006, Red Hat Middleware, LLC, and individual                    *
 * contributors as indicated by the @authors tag. See the                     *
 * copyright.txt in the distribution for a full listing of                    *
 * individual contributors.                                                   *
 *                                                                            *
 * This is free software; you can redistribute it and/or modify it            *
 * under the terms of the GNU Lesser General Public License as                *
 * published by the Free Software Foundation; either version 2.1 of           *
 * the License, or (at your option) any later version.                        *
 *                                                                            *
 * This software is distributed in the hope that it will be useful,           *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU           *
 * Lesser General Public License for more details.                            *
 *                                                                            *
 * You should have received a copy of the GNU Lesser General Public           *
 * License along with this software; if not, write to the Free                *
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA         *
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.                   *
 ******************************************************************************/
package org.jboss.portletbridge.richfaces;

import java.util.Map;

import org.ajax4jsf.context.AjaxContext;
import org.jboss.portletbridge.component.UIPortletAjaxViewRoot;
import org.jboss.portletbridge.renderkit.portlet.PortletAjaxViewRootRenderer;

import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;
import javax.faces.render.Renderer;

/**
 * @author <a href="mailto:whales@redhat.com">Wesley Hales</a>
 * @version $Revision: 630 $
 */
public class RichFacesHelper {

	public RichFacesHelper() {
		AjaxContext.class.getName();
	}

	public AjaxContext getCurrentInstance(FacesContext facesContext) {
		return AjaxContext.getCurrentInstance(facesContext);
	}

	public AjaxContext getCurrentInstance() {
		return AjaxContext.getCurrentInstance();
	}

	public Renderer getViewRootRenderer() {
		return new PortletAjaxViewRootRenderer();
	}

	public Class<? extends UIViewRoot> getViewRootClass() {
		return UIPortletAjaxViewRoot.class;
	}

	public static Object getAjaxContext(FacesContext facesContext) {
		Map<String, Object> requestMap = facesContext.getExternalContext()
				.getRequestMap();
		Object ajaxContext = requestMap.get(AjaxContext.AJAX_CONTEXT_KEY);
		if (null == ajaxContext) {
			ajaxContext = new PortletAjaxContext();
			requestMap.put(AjaxContext.AJAX_CONTEXT_KEY, ajaxContext);
		}
		return ajaxContext;
	}

}
